// -*- c++ -*-

#ifndef JSEMBED_H
#define JSEMBED_H

#include <qvbox.h>
#include <kjs/kjs.h>
#include <kjs/function.h>

class QMultiLineEdit;
class QLineEdit;
class QPushButton;

/**
 * Example of how to embed the KDE ECMAScript interpreter in an app.
 *
 * @version $Id: jsembed.h,v 1.2 2002/02/16 19:55:12 rich Exp $
 * @author Richard Moore, rich@kde.org
 */
class JSEmbed : public QVBox
{
    Q_OBJECT

public:
    JSEmbed();
    ~JSEmbed();

public slots:
    void execute();
    void output( const QString &msg );

private:
    void createGUI();

    QMultiLineEdit *log;
    QLineEdit *cmd;
    QPushButton *run;

    KJScript *js;
};

/**
 * Defines a JS function that prints to the log widget.
 */
class JSEmbedPrint : public KJS::InternalFunctionImp
{
public:
    JSEmbedPrint( JSEmbed *win ) : KJS::InternalFunctionImp() { this->win = win; }
    ~JSEmbedPrint() {}

    KJS::Completion execute( const KJS::List &args );

private:
    JSEmbed *win;
};


#endif // JSEMBED_H

// Local Variables:
// c-basic-offset: 4
// End:

