//  -*- c++ -*-

#ifndef XMLDEMO_H
#define XMLDEMO_H

#include <qvbox.h>
#include <qdom.h>

class KListView;
class KListViewItem;
class QListViewItem;
class QTextBrowser;

/**
 * This example illustrates the use of the Qt DOM classes to parse an
 * XML file. The code parses an XML file to create a tree structured
 * table of contents in a KListView, and allows the user to save the
 * tree as XML or HTML.
 *
 * @version $Id: xmldemo.h,v 1.3 2002/02/18 00:45:47 rich Exp $
 * @author Richard Moore, rich@kde.org 
 */
class XMLDemo : public QVBox
{
    Q_OBJECT

public:
    XMLDemo();
    ~XMLDemo();

    bool load( const QString &filename );

public slots:
    void selected( QListViewItem *i );

protected:
    void updateContents();

    KListViewItem *processDocTag( KListViewItem *parent, QDomElement &elem );
    void processDocument( QDomDocument &node );
    void processChildren( KListViewItem *parent, QDomElement &root );

    QWidget *addHeading( const QString &text, QWidget *w );
    QWidget *addSection( const QString &text, QWidget *w );

private:
    QDomDocument doc;
    KListView *toc;
    QTextBrowser *view;
};

#endif // XMLDEMO_H

// Local Variables:
// c-basic-offset: 4
// End:
